import 'package:safexpay/observer/observable.dart';
import 'package:safexpay/observer/safeXPay_payment_callback.dart';

class SafeXPayPaymentCallbackObservable
    implements Observable<SafeXPayPaymentCallback> {
  static List<SafeXPayPaymentCallback> _observerList =
      <SafeXPayPaymentCallback>[];

  @override
  void register(SafeXPayPaymentCallback observer) {
    if (!_observerList.contains(observer)) {
      _observerList.add(observer);
    }
  }

  @override
  void unRegister(SafeXPayPaymentCallback observer) {
    if (_observerList.contains(observer)) {
      _observerList.remove(observer);
    }
  }

  void notifyOnPaymentComplete(String orderID, String transactionID,
      String paymentID, String paymentStatus) {
    for (final SafeXPayPaymentCallback observer in _observerList) {
      observer.onPaymentComplete(
          orderID, transactionID, paymentID, paymentStatus);
    }
  }

  void notifyOnPaymentCancelled() {
    for (final SafeXPayPaymentCallback observer in _observerList) {
      observer.onPaymentCancelled();
    }
  }

  void notifyOnInitiatePaymentFailure(String errorMessage) {
    for (final SafeXPayPaymentCallback observer in _observerList) {
      observer.onInitiatePaymentFailure(errorMessage);
    }
  }
}
